sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

void Compass_Screen_poll();
void Intro_Screen_poll();
void Cal_Screen_poll();
void Set_Cal_Consts();
extern char SM_state;
extern int heading;

int LSM303DLHC_Init();

void SM_poll(){
  switch (SM_state){
    case 0 : Compass_Screen_poll(); break;       // poll function for Screen 1
    case 1 : Intro_Screen_poll(); break;         // poll function for Screen 2
    case 2 : Cal_Screen_poll(); break;           // poll function for Screen 3
    default : SM_state = 0; break;
  }
}

void Move3sec() {
  PWM1_Start();                       // start PWM1
  PWM2_Start();                       // start PWM2
  delay_ms(3000);
  PWM1_Stop();                       // start PWM1
  PWM2_Stop();                       // start PWM2
}

void main() {
  ANSELB = 0;                // Configure PORTB pins as digital
  ANSELC = 0;                // Configure PORTC pins as digital
  TRISB = 0;                 // Configure PORTB as output
  LATB = 0;                  // Clear PORTB

  Lcd_Init();                        // Initialize Lcd

  Lcd_Cmd(_LCD_CLEAR);               // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
  Lcd_Out(1,1,"Calibration.....");                 // // for digonistic

  I2C1_Init(100000);
  Set_Cal_Consts();
  delay_ms(50);
  LSM303DLHC_Init();
  SM_state = 1;
  Lcd_Out(2,1,"Heading=");          // for digonistic
  while(1){
    SM_poll();
    
  }
}