#line 1 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/Compass.c"
sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;

void Compass_Screen_poll();
void Intro_Screen_poll();
void Cal_Screen_poll();
void Set_Cal_Consts();
extern char SM_state;
extern int heading;

int LSM303DLHC_Init();

void SM_poll(){
 switch (SM_state){
 case 0 : Compass_Screen_poll(); break;
 case 1 : Intro_Screen_poll(); break;
 case 2 : Cal_Screen_poll(); break;
 default : SM_state = 0; break;
 }
}

void Move3sec() {
 PWM1_Start();
 PWM2_Start();
 delay_ms(3000);
 PWM1_Stop();
 PWM2_Stop();
}

void main() {
 ANSELB = 0;
 ANSELC = 0;
 TRISB = 0;
 LATB = 0;

 Lcd_Init();

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,"Calibration.....");

 I2C1_Init(100000);
 Set_Cal_Consts();
 delay_ms(50);
 LSM303DLHC_Init();
 SM_state = 1;
 Lcd_Out(2,1,"Heading=");
 while(1){
 SM_poll();

 }
}
