#line 1 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
#line 1 "d:/programming&cct design/microcontroller/projects/compass/compass3/lsm303dlhc_driver.h"
#line 33 "d:/programming&cct design/microcontroller/projects/compass/compass3/lsm303dlhc_driver.h"
typedef unsigned short u8_t;
typedef unsigned int u16_t;
typedef int i16_t;
typedef u8_t IntPinConf_t;
typedef u8_t Axis_t;
typedef u8_t IntConf_t;

typedef enum {
 MEMS_SUCCESS = 0x01,
 MEMS_ERROR = 0x00
} status_t;

typedef enum {
 MEMS_ENABLE = 0x01,
 MEMS_DISABLE = 0x00
} State_t;

typedef enum {
 ODR_1Hz = 0x01,
 ODR_10Hz = 0x02,
 ODR_25Hz = 0x03,
 ODR_50Hz = 0x04,
 ODR_100Hz = 0x05,
 ODR_200Hz = 0x06,
 ODR_400Hz = 0x07,
 ODR_1620Hz_LP = 0x08,
 ODR_1344Hz_NP_5367HZ_LP = 0x09
} ODR_t;

typedef enum {
 ODR_0_75Hz_M = 0x00,
 ODR_1_5Hz_M = 0x01,
 ODR_3_0Hz_M = 0x02,
 ODR_7_5Hz_M = 0x03,
 ODR_15Hz_M = 0x04,
 ODR_30Hz_M = 0x05,
 ODR_75Hz_M = 0x06,
 ODR_220Hz_M = 0x07
} ODR_M_t;

typedef enum {
 GAIN_1100_M = 0x01,
 GAIN_855_M = 0x02,
 GAIN_670_M = 0x03,
 GAIN_450_M = 0x04,
 GAIN_400_M = 0x05,
 GAIN_330_M = 0x06,
 GAIN_230_M = 0x07
} GAIN_M_t;

typedef enum {
 CONTINUOUS_MODE = 0x00,
 SINGLE_MODE = 0x01,
 SLEEP_MODE = 0x02
} Mode_M_t;

typedef enum {
 POWER_DOWN = 0x00,
 LOW_POWER = 0x01,
 NORMAL = 0x02
} Mode_t;

typedef enum {
 HPM_NORMAL_MODE_RES = 0x00,
 HPM_REF_SIGNAL = 0x01,
 HPM_NORMAL_MODE = 0x02,
 HPM_AUTORESET_INT = 0x03
} HPFMode_t;

typedef enum {
 HPFCF_0 = 0x00,
 HPFCF_1 = 0x01,
 HPFCF_2 = 0x02,
 HPFCF_3 = 0x03
} HPFCutOffFreq_t;

typedef struct {
 i16_t AXIS_X;
 i16_t AXIS_Y;
 i16_t AXIS_Z;
} AccAxesRaw_t;

typedef struct {
 i16_t AXIS_X;
 i16_t AXIS_Y;
 i16_t AXIS_Z;
}MagAxesRaw_t;

typedef enum {
 FULLSCALE_2 = 0x00,
 FULLSCALE_4 = 0x01,
 FULLSCALE_8 = 0x02,
 FULLSCALE_16 = 0x03
} Fullscale_t;

typedef enum {
 BLE_LSB = 0x00,
 BLE_MSB = 0x01
} Endianess_t;

typedef enum {
 SELF_TEST_DISABLE = 0x00,
 SELF_TEST_0 = 0x01,
 SELF_TEST_1 = 0x02
} SelfTest_t;

typedef enum {
 FIFO_BYPASS_MODE = 0x00,
 FIFO_MODE = 0x01,
 FIFO_STREAM_MODE = 0x02,
 FIFO_TRIGGER_MODE = 0x03,
 FIFO_DISABLE = 0x04
} FifoMode_t;

typedef enum {
 TRIG_INT1 = 0x00,
 TRIG_INT2 = 0x01
} TrigInt_t;

typedef enum {
 SPI_4_WIRE = 0x00,
 SPI_3_WIRE = 0x01
} SPIMode_t;

typedef enum {
 X_ENABLE = 0x01,
 X_DISABLE = 0x00,
 Y_ENABLE = 0x02,
 Y_DISABLE = 0x00,
 Z_ENABLE = 0x04,
 Z_DISABLE = 0x00
} AXISenable_t;

typedef enum {
 INT1_6D_4D_DISABLE = 0x00,
 INT1_6D_ENABLE = 0x01,
 INT1_4D_ENABLE = 0x02
} INT_6D_4D_t;

typedef enum {
 UP_SX = 0x44,
 UP_DX = 0x42,
 DW_SX = 0x41,
 DW_DX = 0x48,
 TOP = 0x60,
 BOTTOM = 0x50
} POSITION_6D_t;

typedef enum {
 INT_MODE_OR = 0x00,
 INT_MODE_6D_MOVEMENT = 0x01,
 INT_MODE_AND = 0x02,
 INT_MODE_6D_POSITION = 0x03
} Int1Mode_t;





typedef enum {
DCLICK_Z_P = 0x44,
DCLICK_Z_N = 0xC4,
SCLICK_Z_P = 0x04,
SCLICK_Z_N = 0x84,
DCLICK_Y_P = 0x42,
DCLICK_Y_N = 0xC2,
SCLICK_Y_P = 0x02,
SCLICK_Y_N = 0x82,
DCLICK_X_P = 0x41,
DCLICK_X_N = 0xC1,
SCLICK_X_P = 0x01,
SCLICK_X_N = 0x81,
NO_CLICK = 0x00
} Click_Responce;
#line 467 "d:/programming&cct design/microcontroller/projects/compass/compass3/lsm303dlhc_driver.h"
status_t SetODR(ODR_t ov);
status_t SetMode(Mode_t md);
status_t SetAxis(Axis_t axis);
status_t SetFullScale(Fullscale_t fs);
status_t SetBDU(State_t bdu);
status_t SetBLE(Endianess_t ble);
status_t SetSelfTest(SelfTest_t st);
status_t SetTemperature(State_t state);


status_t HPFClickEnable(State_t hpfe);
status_t HPFAOI1Enable(State_t hpfe);
status_t HPFAOI2Enable(State_t hpfe);
status_t SetHPFMode(HPFMode_t hpf);
status_t SetHPFCutOFF(HPFCutOffFreq_t hpf);
status_t SetFilterDataSel(State_t state);


status_t SetInt1Pin(IntPinConf_t pinConf);
status_t SetInt2Pin(IntPinConf_t pinConf);
status_t Int1LatchEnable(State_t latch);
status_t ResetInt1Latch(void);
status_t SetInt1Configuration(IntConf_t ic);
status_t SetInt2Configuration(IntConf_t ic);
status_t SetInt1Threshold(u8_t ths);
status_t SetInt1Duration(IntConf_t id);
status_t SetIntMode(Int1Mode_t ic);
status_t SetClickCFG(u8_t status);
status_t SetInt6D4DConfiguration(INT_6D_4D_t ic);
status_t GetInt1Src(u8_t* val);
status_t GetInt1SrcBit(u8_t statusBIT);
status_t GetInt2SrcBit(u8_t statusBIT);


status_t FIFOModeEnable(FifoMode_t fm);
status_t SetWaterMark(u8_t wtm);
status_t SetTriggerInt(TrigInt_t tr);
status_t GetFifoSourceReg(u8_t* val);
status_t GetFifoSourceBit(u8_t statusBIT);
status_t GetFifoSourceFSS(u8_t* val);


status_t GetSatusReg(u8_t* val);
status_t GetSatusBit(u8_t statusBIT);
status_t GetAccAxesRaw(AccAxesRaw_t* buff);
status_t GetClickResponce(u8_t* val);
status_t GetTempRaw(i16_t* val);
status_t Get6DPosition(u8_t* val);


status_t SetODR_M(ODR_M_t ov);
status_t SetGainMag(GAIN_M_t Gain);
status_t SetModeMag(Mode_M_t Mode);
status_t GetMagAxesRaw(MagAxesRaw_t* buff);


char LSM303DLHC_Check_Stady_Accel(MagAxesRaw_t *reading);
int LSM303DLHC_Calculate_Heading();
void LSM303DLHC_Calibrate(MagAxesRaw_t *M_max, MagAxesRaw_t *M_min, unsigned int Cycles_No);





u8_t ReadReg(u8_t deviceAddr, u8_t Reg, u8_t* _Data);
u8_t WriteReg(u8_t deviceAddress, u8_t WriteAddr, u8_t _Data);
#line 17 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
extern MagAxesRaw_t data_A;
extern MagAxesRaw_t data_M;
extern MagAxesRaw_t data_M_min, data_M_max;
 char txt1[7];
#line 30 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
u8_t ReadReg(u8_t deviceAddr, u8_t Reg, u8_t* _Data) {
 I2C1_Start();
 I2C1_Wr (deviceAddr);
 I2C1_Wr (Reg);
 delay_us(50);
 I2C1_Repeated_Start();
 I2C1_Wr (deviceAddr+1u);
 *_Data=I2C1_Rd(0u);
 I2C1_Stop();
 return MEMS_SUCCESS;
}
#line 49 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
u8_t WriteReg(u8_t deviceAddress, u8_t WriteAddr, u8_t _Data) {
 u8_t _buffer[2];

 _buffer[0] = WriteAddr;
 _buffer[1] = _Data;

 I2C1_Start();
 I2C1_Wr (deviceAddress);
 I2C1_Wr (_buffer[0]);
 I2C1_Wr (_buffer[1]);
 I2C1_Stop();
 return MEMS_SUCCESS;
}






typedef struct {
 float x;
 float y;
 float z;
} vector;
#line 81 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
void Vector_Cross(const vector *a, const vector *b, vector *out){
 out->x = (a->y)*(b->z) - (a->z)*(b->y);
 out->y = (a->z)*(b->x) - (a->x)*(b->z);
 out->z = (a->x)*(b->y) - (a->y)*(b->x);
}
#line 94 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
float Vector_Dot(const vector *a, const vector *b){
 return a->x*b->x+a->y*b->y+a->z*b->z;
}
#line 105 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
void Vector_Normalize(vector *a){
 float mag;
 mag = a->x*a->x+a->y*a->y+a->z*a->z;
 mag = sqrt(mag);

 a->x /= mag;
 a->y /= mag;
 a->z /= mag;
}
#line 122 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
float Vector_Magnitude(vector *a){
 float mag;
 mag = a->x*a->x+a->y*a->y+a->z*a->z;
 mag = sqrt(mag);
 return mag;
}
#line 142 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
void LSM303DLHC_Average_readings(MagAxesRaw_t *readings, char reading_source){
struct Average_Temp_t{
 long AXIS_X;
 long AXIS_Y;
 long AXIS_Z;
} Average_Temp;
char loop_average;


 loop_average = 0;
 Average_Temp.AXIS_X = 0;
 Average_Temp.AXIS_Y = 0;
 Average_Temp.AXIS_Z = 0;

 for (loop_average = 0; loop_average < 8; loop_average ++){
 if (reading_source ==  0 )
 GetAccAxesRaw(readings);
 else
 GetMagAxesRaw(readings);
 Average_Temp.AXIS_X += readings->AXIS_X;
 Average_Temp.AXIS_Y += readings->AXIS_Y;
 Average_Temp.AXIS_Z += readings->AXIS_Z;
 }

 readings->AXIS_X = Average_Temp.AXIS_X >> 3;
 readings->AXIS_Y = Average_Temp.AXIS_Y >> 3;
 readings->AXIS_Z = Average_Temp.AXIS_Z >> 3;

}
#line 180 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
char LSM303DLHC_Check_Stady_Accel(MagAxesRaw_t *reading){
vector Vector_temp;
float mag_temp;

 LSM303DLHC_Average_readings(reading,  0 );
 Vector_temp.x = (float)reading->AXIS_X;
 Vector_temp.y = (float)reading->AXIS_Y;
 Vector_temp.z = (float)reading->AXIS_Z;
 mag_temp = Vector_Magnitude(&Vector_temp);

 if (mag_temp > 1250)
 return 1;
 else
 return 1;
}
#line 203 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
void LSM303DLHC_Calibrate(MagAxesRaw_t *M_max, MagAxesRaw_t *M_min, unsigned int Cycles_No) {
 int cntr;
 LSM303DLHC_Average_readings(&data_M,  1 );
 data_M_max.AXIS_X = -100;
 data_M_min.AXIS_X = 100;

 data_M_max.AXIS_Y = -100;
 data_M_min.AXIS_Y = 100;

 data_M_max.AXIS_Z = -100;
 data_M_min.AXIS_Z = 100;

 for(cntr = 0; cntr < Cycles_No; cntr++) {

 if (LSM303DLHC_Check_Stady_Accel(&data_A)){

 LSM303DLHC_Average_readings(&data_M,  1 );

 if (data_M.AXIS_X >= data_M_max.AXIS_X) data_M_max.AXIS_X = data_M.AXIS_X;
 if (data_M.AXIS_X <= data_M_min.AXIS_X) data_M_min.AXIS_X = data_M.AXIS_X;

 if (data_M.AXIS_Y >= data_M_max.AXIS_Y) data_M_max.AXIS_Y = data_M.AXIS_Y;
 if (data_M.AXIS_Y <= data_M_min.AXIS_Y) data_M_min.AXIS_Y = data_M.AXIS_Y;

 if (data_M.AXIS_Z >= data_M_max.AXIS_Z) data_M_max.AXIS_Z = data_M.AXIS_Z;
 if (data_M.AXIS_Z <= data_M_min.AXIS_Z) data_M_min.AXIS_Z = data_M.AXIS_Z;
 }
 }
}
#line 240 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
int LSM303DLHC_Calculate_Heading(){
 vector v_data_M;
 vector v_data_A;
 vector E;
 vector N;
 vector axis = {0, 1 , 0};
 int tmp_heading;
 float temp1;
 float temp2;


 LSM303DLHC_Average_readings(&data_A,  0 );
 LSM303DLHC_Average_readings(&data_M,  1 );


 v_data_M.x = (float)data_M.AXIS_X;
 v_data_M.y = (float)data_M.AXIS_Y;
 v_data_M.z = (float)data_M.AXIS_Z;

 v_data_A.x = (float)data_A.AXIS_X;
 v_data_A.y = (float)data_A.AXIS_Y;
 v_data_A.z = (float)data_A.AXIS_Z;


 v_data_M.x = (v_data_M.x - data_M_min.AXIS_X) / (data_M_max.AXIS_X - data_M_min.AXIS_X) * 2 - 1.0;
 v_data_M.y = (v_data_M.y - data_M_min.AXIS_Y) / (data_M_max.AXIS_Y - data_M_min.AXIS_Y) * 2 - 1.0;
 v_data_M.z = (v_data_M.z - data_M_min.AXIS_Z) / (data_M_max.AXIS_Z - data_M_min.AXIS_Z) * 2 - 1.0;


 Vector_Normalize(&v_data_A);


 E.x = (v_data_M.y)*(v_data_A.z) - (v_data_M.z)*(v_data_A.y);
 E.y = (v_data_M.z)*(v_data_A.x) - (v_data_M.x)*(v_data_A.z);
 E.z = (v_data_M.x)*(v_data_A.y) - (v_data_M.y)*(v_data_A.x);


 N.x = (v_data_A.y)*(E.z) - (v_data_A.z)*(E.y);
 N.y = (v_data_A.z)*(E.x) - (v_data_A.x)*(E.z);
 N.z = (v_data_A.x)*(E.y) - (v_data_A.y)*(E.x);

 Vector_Normalize(&N);
 Vector_Normalize(&E);

 temp1=E.x*axis.x+E.y*axis.y+E.z*axis.z;
 temp2=N.x*axis.x+N.y*axis.y+N.z*axis.z;
 tmp_heading = ceil(atan2 (temp1, temp2) * 180 /  3.1415 );
 if (tmp_heading < 0) tmp_heading += 360;

 return tmp_heading;
}
#line 299 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
int LSM303DLHC_Init() {
char response;


 response = SetODR(ODR_25Hz);


 response = SetODR_M(ODR_220Hz_M);


 response = SetMode(NORMAL);


 response = SetModeMag(CONTINUOUS_MODE);


 response = SetFullScale(FULLSCALE_2);


 response = SetGainMag(GAIN_1100_M);


 response = SetAxis(X_ENABLE | Y_ENABLE | Z_ENABLE);

 return 1;
}
#line 335 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetODR(ODR_t ov){
 u8_t value;

 if( !ReadReg( 0x32 ,  0x20 , &value) )
 return MEMS_ERROR;

 value &= 0x0f;
 value |= ov<<4;

 if( !WriteReg( 0x32 ,  0x20 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 357 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetODR_M(ODR_M_t ov){
 u8_t value;

 if( !ReadReg( 0x3C ,  0x00 , &value) )
 return MEMS_ERROR;

 value &= 0x80;
 value |= ov<< ( (2) ) ;

 if( !WriteReg( 0x3C ,  0x00 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 379 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetTemperature(State_t state){
 u8_t value;

 if( !ReadReg( 0x3C ,  0x00 , &value) )
 return MEMS_ERROR;

 value &= 0x7F;
 value |= state<< ( (7) ) ;

 if( !WriteReg( 0x3C ,  0x00 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 401 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetGainMag(GAIN_M_t Gain){
 u8_t value;

 if( !ReadReg( 0x3C ,  0x01 , &value) )
 return MEMS_ERROR;

 value &= 0x00;
 value |= Gain<< ( (5) ) ;

 if( !WriteReg( 0x3C ,  0x01 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 423 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetModeMag(Mode_M_t Mode){
 u8_t value;

 if( !ReadReg( 0x3C ,  0x02 , &value) )
 return MEMS_ERROR;

 value &= 0x00;
 value |= Mode<< ( (0) ) ;

 if( !WriteReg( 0x3C ,  0x02 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 445 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetTempRaw(i16_t* val) {
 u8_t valueH;

 if( !ReadReg( 0x3C ,  0x31 , &valueH) )
 return MEMS_ERROR;

 *val = 25 + (i16_t)(valueH);

 return MEMS_SUCCESS;
}
#line 463 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetMode(Mode_t md) {
 u8_t value;
 u8_t value2;
 static u8_t ODR_old_value;

 if( !ReadReg( 0x32 ,  0x20 , &value) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x23 , &value2) )
 return MEMS_ERROR;

 if((value & 0xF0)==0) value = value | (ODR_old_value & 0xF0);

 switch(md) {

 case POWER_DOWN:
 ODR_old_value = value;
 value &= 0x0F;
 break;

 case NORMAL:
 value &= 0xF7;
 value |= ( 0x00 << ( (3) ) );
 value2 &= 0xF7;
 value2 |= ( 0x01 << ( (3) ) );
 break;

 case LOW_POWER:
 value &= 0xF7;
 value |= ( 0x01 << ( (3) ) );
 value2 &= 0xF7;
 value2 |= ( 0x00 << ( (3) ) );
 break;

 default:
 return MEMS_ERROR;
 }

 if( !WriteReg( 0x32 ,  0x20 , value) )
 return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x23 , value2) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 518 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetAxis(Axis_t axis) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x20 , &value) )
 return MEMS_ERROR;
 value &= 0xF8;
 value |= (0x07 & axis);

 if( !WriteReg( 0x32 ,  0x20 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 539 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetFullScale(Fullscale_t fs) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x23 , &value) )
 return MEMS_ERROR;

 value &= 0xCF;
 value |= (fs<< ( (4) ) );

 if( !WriteReg( 0x32 ,  0x23 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 561 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetBDU(State_t bdu) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x23 , &value) )
 return MEMS_ERROR;

 value &= 0x7F;
 value |= (bdu<< ( (7) ) );

 if( !WriteReg( 0x32 ,  0x23 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 583 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetBLE(Endianess_t ble) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x23 , &value) )
 return MEMS_ERROR;

 value &= 0xBF;
 value |= (ble<< ( (6) ) );

 if( !WriteReg( 0x32 ,  0x23 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 605 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetSelfTest(SelfTest_t st) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x23 , &value) )
 return MEMS_ERROR;

 value &= 0xF9;
 value |= (st<< ( (1) ) );

 if( !WriteReg( 0x32 ,  0x23 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 627 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t HPFClickEnable(State_t hpfe) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x21 , &value) )
 return MEMS_ERROR;

 value &= 0xFB;
 value |= (hpfe<< ( (2) ) );

 if( !WriteReg( 0x32 ,  0x21 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 649 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t HPFAOI1Enable(State_t hpfe) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x21 , &value) )
 return MEMS_ERROR;

 value &= 0xFE;
 value |= (hpfe<< ( (0) ) );

 if( !WriteReg( 0x32 ,  0x21 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 671 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t HPFAOI2Enable(State_t hpfe) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x21 , &value) )
 return MEMS_ERROR;

 value &= 0xFD;
 value |= (hpfe<< ( (1) ) );

 if( !WriteReg( 0x32 ,  0x21 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 693 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetHPFMode(HPFMode_t hpm) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x21 , &value) )
 return MEMS_ERROR;

 value &= 0x3F;
 value |= (hpm<< ( (6) ) );

 if( !WriteReg( 0x32 ,  0x21 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 715 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetHPFCutOFF(HPFCutOffFreq_t hpf) {
 u8_t value;

 if (hpf > 3)
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x21 , &value) )
 return MEMS_ERROR;

 value &= 0xCF;
 value |= (hpf<< ( (4) ) );

 if( !WriteReg( 0x32 ,  0x21 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;

}
#line 741 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetFilterDataSel(State_t state) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x21 , &value) )
 return MEMS_ERROR;

 value &= 0xF7;
 value |= (state<< ( (3) ) );

 if( !WriteReg( 0x32 ,  0x21 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;

}
#line 771 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt1Pin(IntPinConf_t pinConf) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x22 , &value) )
 return MEMS_ERROR;

 value &= 0x00;
 value |= pinConf;

 if( !WriteReg( 0x32 ,  0x22 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 799 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt2Pin(IntPinConf_t pinConf) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x25 , &value) )
 return MEMS_ERROR;

 value &= 0x00;
 value |= pinConf;

 if( !WriteReg( 0x32 ,  0x25 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 825 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetClickCFG(u8_t status) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x38 , &value) )
 return MEMS_ERROR;

 value &= 0xC0;
 value |= status;

 if( !WriteReg( 0x32 ,  0x38 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 847 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetClickTHS(u8_t ths) {

 if(ths>127) return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x3A , ths) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 864 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetClickLIMIT(u8_t t_limit) {

 if(t_limit>127) return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x3B , t_limit) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 881 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetClickLATENCY(u8_t t_latency) {

 if(t_latency>255) return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x3C , t_latency) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 898 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetClickWINDOW(u8_t t_window) {

 if(t_window>255) return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x3D , t_window) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 915 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetClickResponce(u8_t* res) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x39 , &value) )
 return MEMS_ERROR;

 value &= 0x7F;

 if((value &  0x40 )==0) { *res = NO_CLICK; return MEMS_SUCCESS;}
 else {
 if (value &  0x20 ){
 if (value &  0x08 ){
 if (value &  0x04 ) {*res = DCLICK_Z_N; return MEMS_SUCCESS;}
 if (value &  0x02 ) {*res = DCLICK_Y_N; return MEMS_SUCCESS;}
 if (value &  0x01 ) {*res = DCLICK_X_N; return MEMS_SUCCESS;}
 }
 else{
 if (value &  0x04 ) {*res = DCLICK_Z_P; return MEMS_SUCCESS;}
 if (value &  0x02 ) {*res = DCLICK_Y_P; return MEMS_SUCCESS;}
 if (value &  0x01 ) {*res = DCLICK_X_P; return MEMS_SUCCESS;}
 }
 }
 else{
 if (value &  0x08 ){
 if (value &  0x04 ) {*res = SCLICK_Z_N; return MEMS_SUCCESS;}
 if (value &  0x02 ) {*res = SCLICK_Y_N; return MEMS_SUCCESS;}
 if (value &  0x01 ) {*res = SCLICK_X_N; return MEMS_SUCCESS;}
 }
 else{
 if (value &  0x04 ) {*res = SCLICK_Z_P; return MEMS_SUCCESS;}
 if (value &  0x02 ) {*res = SCLICK_Y_P; return MEMS_SUCCESS;}
 if (value &  0x01 ) {*res = SCLICK_X_P; return MEMS_SUCCESS;}
 }
 }
 }
 return MEMS_ERROR;
}
#line 960 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t Int1LatchEnable(State_t latch) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x24 , &value) )
 return MEMS_ERROR;

 value &= 0xF7;
 value |= latch<< ( (3) ) ;

 if( !WriteReg( 0x32 ,  0x24 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 982 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t ResetInt1Latch(void) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x31 , &value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 999 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt1Configuration(IntConf_t ic) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x30 , &value) )
 return MEMS_ERROR;

 value &= 0x40;
 value |= ic;

 if( !WriteReg( 0x32 ,  0x30 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1022 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt2Configuration(IntConf_t ic) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x34 , &value) )
 return MEMS_ERROR;

 value &= 0x40;
 value |= ic;

 if( !WriteReg( 0x32 ,  0x34 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1044 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetIntMode(Int1Mode_t int_mode) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x30 , &value) )
 return MEMS_ERROR;

 value &= 0x3F;
 value |= (int_mode<< ( (6) ) );

 if( !WriteReg( 0x32 ,  0x30 , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1066 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt6D4DConfiguration(INT_6D_4D_t ic) {
 u8_t value;
 u8_t value2;

 if( !ReadReg( 0x32 ,  0x30 , &value) )
 return MEMS_ERROR;
 if( !ReadReg( 0x32 ,  0x24 , &value2) )
 return MEMS_ERROR;

 if(ic == INT1_6D_ENABLE){
 value &= 0xBF;
 value |= (MEMS_ENABLE<< ( (6) ) );
 value2 &= 0xFB;
 value2 |= (MEMS_DISABLE<< ( (2) ) );
 }

 if(ic == INT1_4D_ENABLE){
 value &= 0xBF;
 value |= (MEMS_ENABLE<< ( (6) ) );
 value2 &= 0xFB;
 value2 |= (MEMS_ENABLE<< ( (2) ) );
 }

 if(ic == INT1_6D_4D_DISABLE){
 value &= 0xBF;
 value |= (MEMS_DISABLE<< ( (6) ) );
 value2 &= 0xFB;
 value2 |= (MEMS_DISABLE<< ( (2) ) );
 }

 if( !WriteReg( 0x32 ,  0x30 , value) )
 return MEMS_ERROR;
 if( !WriteReg( 0x32 ,  0x24 , value2) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1111 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t Get6DPosition(u8_t* val){
 u8_t value;

 if( !ReadReg( 0x32 ,  0x31 , &value) )
 return MEMS_ERROR;

 value &= 0x7F;

 switch (value){
 case UP_SX: *val = UP_SX; break;
 case UP_DX: *val = UP_DX; break;
 case DW_SX: *val = DW_SX; break;
 case DW_DX: *val = DW_DX; break;
 case TOP: *val = TOP; break;
 case BOTTOM: *val = BOTTOM; break;
 }

return MEMS_SUCCESS;
}
#line 1138 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt1Threshold(u8_t ths) {
 if (ths > 127)
 return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x32 , ths) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1155 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetInt1Duration(IntConf_t id) {

 if (id > 127)
 return MEMS_ERROR;

 if( !WriteReg( 0x32 ,  0x33 , id) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1173 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t FIFOModeEnable(FifoMode_t fm) {
 u8_t value;

 if(fm == FIFO_DISABLE) {
 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;
 value &= 0x1f;
 value |= (FIFO_BYPASS_MODE<< ( (6) ) );
 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x24 , &value) )
 return MEMS_ERROR;
 value &= 0xBF;
 if( !WriteReg( 0x32 ,  0x24 , value) )
 return MEMS_ERROR;
 }

 if(fm == FIFO_BYPASS_MODE) {
 if( !ReadReg( 0x32 ,  0x24 , &value) )
 return MEMS_ERROR;
 value &= 0xBF;
 value |=  0x01 << ( (6) ) ;
 if( !WriteReg( 0x32 ,  0x24 , value) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;
 value &= 0x1f;
 value |= (fm<< ( (6) ) );
 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;
 }

 if(fm == FIFO_MODE) {
 if( !ReadReg( 0x32 ,  0x24 , &value) )
 return MEMS_ERROR;
 value &= 0xBF;
 value |=  0x01 << ( (6) ) ;
 if( !WriteReg( 0x32 ,  0x24 , value) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;
 value &= 0x1f;
 value |= (fm<< ( (6) ) );
 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;
 }

 if(fm == FIFO_STREAM_MODE) {
 if( !ReadReg( 0x32 ,  0x24 , &value) )
 return MEMS_ERROR;
 value &= 0xBF;
 value |=  0x01 << ( (6) ) ;
 if( !WriteReg( 0x32 ,  0x24 , value) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;
 value &= 0x1f;
 value |= (fm<< ( (6) ) );
 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;
 }

 if(fm == FIFO_TRIGGER_MODE) {
 if( !ReadReg( 0x32 ,  0x24 , &value) )
 return MEMS_ERROR;
 value &= 0xBF;
 value |=  0x01 << ( (6) ) ;
 if( !WriteReg( 0x32 ,  0x24 , value) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;
 value &= 0x1f;
 value |= (fm<< ( (6) ) );
 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;
 }
 return MEMS_SUCCESS;
}
#line 1264 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetTriggerInt(TrigInt_t tr) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;

 value &= 0xDF;
 value |= (tr<< ( (5) ) );

 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1286 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t SetWaterMark(u8_t wtm) {
 u8_t value;

 if(wtm > 31)
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2E , &value) )
 return MEMS_ERROR;

 value &= 0xE0;
 value |= wtm;

 if( !WriteReg( 0x32 ,  0x2E , value) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1311 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetSatusReg(u8_t* val) {
 if( !ReadReg( 0x32 ,  0x27 , val) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1326 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetSatusBit(u8_t statusBIT) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x27 , &value) )
 return MEMS_ERROR;

 switch (statusBIT){
 case  0x80 : if(value &=  0x80 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x40 : if(value &=  0x40 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x20 : if(value &=  0x20 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x10 : if(value &=  0x10 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x08 : if(value &=  0x08 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x04 : if(value &=  0x04 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x02 : if(value &=  0x02 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 case  0x01 : if(value &=  0x01 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;

 }
return MEMS_ERROR;
}
#line 1361 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetAccAxesRaw(MagAxesRaw_t* buff) {
 u8_t valueL;
 u8_t valueH;

 if( !ReadReg( 0x32 ,  0x28 , &valueL) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x29 , &valueH) )
 return MEMS_ERROR;

 buff->AXIS_X = (i16_t)( (valueH << 8) | valueL )/16;

 if( !ReadReg( 0x32 ,  0x2A , &valueL) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2B , &valueH) )
 return MEMS_ERROR;

 buff->AXIS_Y = (i16_t)( (valueH << 8) | valueL )/16;

 if( !ReadReg( 0x32 ,  0x2C , &valueL) )
 return MEMS_ERROR;

 if( !ReadReg( 0x32 ,  0x2D , &valueH) )
 return MEMS_ERROR;

 buff->AXIS_Z = (i16_t)( (valueH << 8) | valueL )/16;

 return MEMS_SUCCESS;
}
#line 1399 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetMagAxesRaw(MagAxesRaw_t* buff) {
 u8_t valueL;
 u8_t valueH;

 if( !ReadReg( 0x3C ,  0x04 , &valueL) )
 return MEMS_ERROR;

 if( !ReadReg( 0x3C ,  0x03 , &valueH) )
 return MEMS_ERROR;

 buff->AXIS_X = (i16_t)( (valueH << 8) | valueL );

 if( !ReadReg( 0x3C ,  0x08 , &valueL) )
 return MEMS_ERROR;

 if( !ReadReg( 0x3C ,  0x07 , &valueH) )
 return MEMS_ERROR;

 buff->AXIS_Y = (i16_t)( (valueH << 8) | valueL );

 if( !ReadReg( 0x3C ,  0x06 , &valueL) )
 return MEMS_ERROR;

 if( !ReadReg( 0x3C ,  0x05 , &valueH) )
 return MEMS_ERROR;

 buff->AXIS_Z = (i16_t)( (valueH << 8) | valueL );

 return MEMS_SUCCESS;
}
#line 1438 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetInt1Src(u8_t* val) {

 if( !ReadReg( 0x32 ,  0x31 , val) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1453 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetInt1SrcBit(u8_t statusBIT) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x31 , &value) )
 return MEMS_ERROR;

 if(statusBIT ==  0x40 ){
 if(value &=  0x40 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x20 ){
 if(value &=  0x20 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x10 ){
 if(value &=  0x10 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x08 ){
 if(value &=  0x08 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x04 ){
 if(value &=  0x04 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x02 ){
 if(value &=  0x02 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x01 ){
 if(value &=  0x01 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }
return MEMS_ERROR;
}
#line 1503 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetInt2SrcBit(u8_t statusBIT) {
 u8_t value;

 if( !ReadReg( 0x32 ,  0x35 , &value) )
 return MEMS_ERROR;

 if(statusBIT ==  0x40 ){
 if(value &=  0x40 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x20 ){
 if(value &=  0x20 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x10 ){
 if(value &=  0x10 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x08 ){
 if(value &=  0x08 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x04 ){
 if(value &=  0x04 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x02 ){
 if(value &=  0x02 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x01 ){
 if(value &=  0x01 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }
return MEMS_ERROR;
}
#line 1553 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetFifoSourceReg(u8_t* val) {

 if( !ReadReg( 0x32 ,  0x2F , val) )
 return MEMS_ERROR;

 return MEMS_SUCCESS;
}
#line 1568 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetFifoSourceBit(u8_t statusBIT){
 u8_t value;

 if( !ReadReg( 0x32 ,  0x2F , &value) )
 return MEMS_ERROR;

 if(statusBIT ==  0x80 ){
 if(value &=  0x80 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x40 ){
 if(value &=  0x40 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }

 if(statusBIT ==  0x20 ){
 if(value &=  0x20 ) return MEMS_SUCCESS;
 else return MEMS_ERROR;
 }
return MEMS_ERROR;
}
#line 1598 "D:/programming&CCt Design/Microcontroller/Projects/Compass/Compass3/lsm303dlhc_driver.c"
status_t GetFifoSourceFSS(u8_t* val){
 u8_t value;

 if( !ReadReg( 0x32 ,  0x2F , &value) )
 return MEMS_ERROR;

 value &= 0x1F;
 *val = value;

 return MEMS_SUCCESS;
}
